# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from kiln_connect.openapi_client.models.sol_reward_by_day import SOLRewardByDay
from kiln_connect.openapi_client.models.sol_reward_by_epoch import SOLRewardByEpoch
from typing import Any, List
from pydantic import StrictStr, Field

GETSOLREWARDS200RESPONSEDATAINNER_ONE_OF_SCHEMAS = ["SOLRewardByDay", "SOLRewardByEpoch"]

class GetSolRewards200ResponseDataInner(BaseModel):
    """
    GetSolRewards200ResponseDataInner
    """
    # data type: SOLRewardByEpoch
    oneof_schema_1_validator: Optional[SOLRewardByEpoch] = None
    # data type: SOLRewardByDay
    oneof_schema_2_validator: Optional[SOLRewardByDay] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(GETSOLREWARDS200RESPONSEDATAINNER_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = cls()
        error_messages = []
        match = 0
        # validate data type: SOLRewardByEpoch
        if type(v) is not SOLRewardByEpoch:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLRewardByEpoch`")
        else:
            match += 1

        # validate data type: SOLRewardByDay
        if type(v) is not SOLRewardByDay:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLRewardByDay`")
        else:
            match += 1

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GetSolRewards200ResponseDataInner with oneOf schemas: SOLRewardByDay, SOLRewardByEpoch. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetSolRewards200ResponseDataInner with oneOf schemas: SOLRewardByDay, SOLRewardByEpoch. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> GetSolRewards200ResponseDataInner:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> GetSolRewards200ResponseDataInner:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        match = 0

        # deserialize data into SOLRewardByEpoch
        try:
            instance.actual_instance = SOLRewardByEpoch.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into SOLRewardByDay
        try:
            instance.actual_instance = SOLRewardByDay.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GetSolRewards200ResponseDataInner with oneOf schemas: SOLRewardByDay, SOLRewardByEpoch. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetSolRewards200ResponseDataInner with oneOf schemas: SOLRewardByDay, SOLRewardByEpoch. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

