# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from kiln_connect.openapi_client.models.xtz_operation_activation import XTZOperationActivation
from kiln_connect.openapi_client.models.xtz_operation_delegate import XTZOperationDelegate
from kiln_connect.openapi_client.models.xtz_operation_payment import XTZOperationPayment
from kiln_connect.openapi_client.models.xtz_operation_undelegate import XTZOperationUndelegate
from typing import Any, List
from pydantic import StrictStr, Field

GETXTZOPERATIONS200RESPONSEDATAINNER_ONE_OF_SCHEMAS = ["XTZOperationActivation", "XTZOperationDelegate", "XTZOperationPayment", "XTZOperationUndelegate"]

class GetXtzOperations200ResponseDataInner(BaseModel):
    """
    GetXtzOperations200ResponseDataInner
    """
    # data type: XTZOperationDelegate
    oneof_schema_1_validator: Optional[XTZOperationDelegate] = None
    # data type: XTZOperationUndelegate
    oneof_schema_2_validator: Optional[XTZOperationUndelegate] = None
    # data type: XTZOperationActivation
    oneof_schema_3_validator: Optional[XTZOperationActivation] = None
    # data type: XTZOperationPayment
    oneof_schema_4_validator: Optional[XTZOperationPayment] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(GETXTZOPERATIONS200RESPONSEDATAINNER_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = cls()
        error_messages = []
        match = 0
        # validate data type: XTZOperationDelegate
        if type(v) is not XTZOperationDelegate:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZOperationDelegate`")
        else:
            match += 1

        # validate data type: XTZOperationUndelegate
        if type(v) is not XTZOperationUndelegate:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZOperationUndelegate`")
        else:
            match += 1

        # validate data type: XTZOperationActivation
        if type(v) is not XTZOperationActivation:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZOperationActivation`")
        else:
            match += 1

        # validate data type: XTZOperationPayment
        if type(v) is not XTZOperationPayment:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZOperationPayment`")
        else:
            match += 1

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GetXtzOperations200ResponseDataInner with oneOf schemas: XTZOperationActivation, XTZOperationDelegate, XTZOperationPayment, XTZOperationUndelegate. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetXtzOperations200ResponseDataInner with oneOf schemas: XTZOperationActivation, XTZOperationDelegate, XTZOperationPayment, XTZOperationUndelegate. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> GetXtzOperations200ResponseDataInner:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> GetXtzOperations200ResponseDataInner:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `XTZOperationActivation`
        if _data_type == "XTZOperationActivation":
            instance.actual_instance = XTZOperationActivation.from_json(json_str)
            return instance

        # check if data type is `XTZOperationDelegate`
        if _data_type == "XTZOperationDelegate":
            instance.actual_instance = XTZOperationDelegate.from_json(json_str)
            return instance

        # check if data type is `XTZOperationPayment`
        if _data_type == "XTZOperationPayment":
            instance.actual_instance = XTZOperationPayment.from_json(json_str)
            return instance

        # check if data type is `XTZOperationUndelegate`
        if _data_type == "XTZOperationUndelegate":
            instance.actual_instance = XTZOperationUndelegate.from_json(json_str)
            return instance

        # check if data type is `XTZOperationActivation`
        if _data_type == "activation":
            instance.actual_instance = XTZOperationActivation.from_json(json_str)
            return instance

        # check if data type is `XTZOperationDelegate`
        if _data_type == "delegate":
            instance.actual_instance = XTZOperationDelegate.from_json(json_str)
            return instance

        # check if data type is `XTZOperationPayment`
        if _data_type == "payment":
            instance.actual_instance = XTZOperationPayment.from_json(json_str)
            return instance

        # check if data type is `XTZOperationUndelegate`
        if _data_type == "undelegate":
            instance.actual_instance = XTZOperationUndelegate.from_json(json_str)
            return instance

        # deserialize data into XTZOperationDelegate
        try:
            instance.actual_instance = XTZOperationDelegate.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into XTZOperationUndelegate
        try:
            instance.actual_instance = XTZOperationUndelegate.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into XTZOperationActivation
        try:
            instance.actual_instance = XTZOperationActivation.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into XTZOperationPayment
        try:
            instance.actual_instance = XTZOperationPayment.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GetXtzOperations200ResponseDataInner with oneOf schemas: XTZOperationActivation, XTZOperationDelegate, XTZOperationPayment, XTZOperationUndelegate. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetXtzOperations200ResponseDataInner with oneOf schemas: XTZOperationActivation, XTZOperationDelegate, XTZOperationPayment, XTZOperationUndelegate. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

