# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class SOLOperationCreateAccountWithSeed(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    type: Optional[StrictStr] = Field(None, description="Operation type")
    time: Optional[datetime] = Field(None, description="Date of the operation")
    tx_hash: Optional[StrictStr] = Field(None, description="Transaction hash")
    tx_fee: Optional[StrictStr] = Field(None, description="Fee charged to the associated transaction in Lamport")
    tx_memo: Optional[StrictStr] = Field(None, description="Memo associated with the transaction")
    block: Optional[StrictInt] = Field(None, description="Block number of the operation")
    stake_account: Optional[StrictStr] = Field(None, description="Created stake account")
    amount: Optional[StrictStr] = Field(None, description="Amount delegated to the new stake account in Lamport")
    stake_authority: Optional[StrictStr] = Field(None, description="Stake authority")
    __properties = ["type", "time", "tx_hash", "tx_fee", "tx_memo", "block", "stake_account", "amount", "stake_authority"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SOLOperationCreateAccountWithSeed:
        """Create an instance of SOLOperationCreateAccountWithSeed from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if tx_memo (nullable) is None
        if self.tx_memo is None:
            _dict['tx_memo'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SOLOperationCreateAccountWithSeed:
        """Create an instance of SOLOperationCreateAccountWithSeed from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return SOLOperationCreateAccountWithSeed.parse_obj(obj)

        _obj = SOLOperationCreateAccountWithSeed.parse_obj({
            "type": obj.get("type"),
            "time": obj.get("time"),
            "tx_hash": obj.get("tx_hash"),
            "tx_fee": obj.get("tx_fee"),
            "tx_memo": obj.get("tx_memo"),
            "block": obj.get("block"),
            "stake_account": obj.get("stake_account"),
            "amount": obj.get("amount"),
            "stake_authority": obj.get("stake_authority")
        })
        return _obj

