# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class XTZOperationDelegate(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    type: Optional[StrictStr] = Field(None, description="Type of the operation")
    var_date: Optional[datetime] = Field(None, alias="date", description="When did the operation occur in an RFC3339 format")
    staker_address: Optional[StrictStr] = Field(None, description="The wallet address for the stake")
    baker_address: Optional[StrictStr] = Field(None, description="The baker address to which the wallet is staked")
    operation: Optional[StrictStr] = Field(None, description="The operation hash")
    operation_gas_used: Optional[StrictStr] = Field(None, description="The operation gas used if any")
    baker_fee: Optional[StrictStr] = Field(None, description="The operation baker fee if applicable")
    block: Optional[StrictInt] = Field(None, description="The block number in which the operation was included")
    amount: Optional[StrictStr] = Field(None, description="The delegated amount")
    __properties = ["type", "date", "staker_address", "baker_address", "operation", "operation_gas_used", "baker_fee", "block", "amount"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> XTZOperationDelegate:
        """Create an instance of XTZOperationDelegate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> XTZOperationDelegate:
        """Create an instance of XTZOperationDelegate from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return XTZOperationDelegate.parse_obj(obj)

        _obj = XTZOperationDelegate.parse_obj({
            "type": obj.get("type"),
            "var_date": obj.get("date"),
            "staker_address": obj.get("staker_address"),
            "baker_address": obj.get("baker_address"),
            "operation": obj.get("operation"),
            "operation_gas_used": obj.get("operation_gas_used"),
            "baker_fee": obj.get("baker_fee"),
            "block": obj.get("block"),
            "amount": obj.get("amount")
        })
        return _obj

